      SUBROUTINE CSD(Z_P,Z_T,E_KIN,TTHICK_M,TTHICK_A)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C     Calculates ...
C     
C     Z_P      :
C     Z_T      : 
C     E_KIN    :
C     TTHICK_M :
C     TTHICK_A :
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

      COMMON /RESULT1/ EIKO_1,EIKO_2,BORN_1,BORN_2,REC_1,REC_2
      COMMON /RESULT2/ D_CAPT,D_IONIS
      COMMON /RESULT8/ ETHICK_M,ETHICK_A,TAU_M
      COMMON /CONSTAN/ AU_FC,EM_FC,C_FC,ALPHA_FC,A0_FC,RY_FC,PI_FC,U_FC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      CALL NRC(Z_P,Z_T,E_KIN,EIKO_1,EIKO_2)

      ZPS = Z_P
      CALL REC(Z_P,Z_T,E_KIN,REC_1)

      ZPS = Z_P - 0.3D0
      CALL REC(ZPS,Z_T,E_KIN,REC_2)

      ZTS = Z_T
      CALL ION(Z_P,ZTS,E_KIN,BORN_1)

      ZPS = Z_P - 0.3D0
      CALL ION(ZPS,ZTS,E_KIN,BORN_2)

C     Normalization factor (Anholt, PRA 1979)
      CNORM  = (1.D0 + (Z_P*ALPHA_FC/2.D0)**2)**(-2)
      BORN_1 = BORN_1*     CNORM
      BORN_2 = BORN_2*2.D0*CNORM

      D_IONIS = BORN_1*1.D-1
      D_CAPT  = EIKO_1*1.D-1

      SIGKREC = REC_2/(1.2002D0)
      REC_2   = REC_2   - SIGKREC/2.D0

      SIGMA01 = EIKO_1  + REC_1
      SIGMA12 = EIKO_2  + REC_2
      SIGMA02 = D_CAPT
      SIGMA10 = BORN_1 
      SIGMA21 = BORN_2 
      SIGMA20 = D_IONIS

      CALL TARGET (Z_T,A_T,RHO)

C     equilibrium thickness according to Thieberger et al.:
      TAU_A = 4.6D0/(SIGMA10+SIGMA01/2)  ! atoms/cm2  
      TAU_M = TAU_A*A_T*U_FC             ! mg/cm2

C     find equilibrium target thickness
      XN2 = 1.D0/SIGMA10
      XN1 = XN2*0.9999
      DO 123 I=1,30
        FRN1=0.0D0
        FRN2=0.0D0
        CALL FRACTION
     &  (SIGMA01,SIGMA02,SIGMA10,SIGMA12,SIGMA20,SIGMA21,XN2,FRN2)
        CALL FRACTION
     &  (SIGMA01,SIGMA02,SIGMA10,SIGMA12,SIGMA20,SIGMA21,XN1,FRN1)
        XN  = XN1-(XN1-XN2)*FRN1/(FRN1-FRN2)
        XN2 = XN1
        XN1 = XN
        IF (FRN2.LT.1.D-03) GOTO 234
123   CONTINUE    
  
      WRITE(*,*) 'Convergence cannot be reached'
234   ETHICK_A = XN                      ! atoms/cm2
      ETHICK_M = ETHICK_A*A_T*U_FC       ! mg/cm2
 
C     calculate charge-state distribution for the given target thickness
      TTHICK_A = TTHICK_M/(A_T*U_FC)     ! atoms/cm2
      X = 1.0D0
      CALL FRACTION
     &(SIGMA01,SIGMA02,SIGMA10,SIGMA12,SIGMA20,SIGMA21,TTHICK_A,X)




      RETURN
      END
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC



      SUBROUTINE FRACTION
     &(SIG01,SIG02,SIG10,SIG12,SIG20,SIG21,X1,X2)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C    SIGij    : charge-exchange cross section i-->j
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      DOUBLE PRECISION  P(0:3,0:3),N(0:3,0:3)

      COMMON /RESULT3/ FE0,FE1,FE2
      COMMON /RESULT4/ F00,F01,F02
      COMMON /RESULT5/ F10,F11,F12
      COMMON /RESULT6/ F20,F21,F22
      COMMON /INITCSD/ FR0,FR1,FR2,R_INIT,D0,D1,D2
      COMMON /CONSTAN/ AU_FC,EM_FC,C_FC,ALPHA_FC,A0_FC,RY_FC,PI_FC,U_FC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      PI    = X1

      ALPHA = SIG01 + SIG02
      BETA  = SIG10 + SIG12
      GAMMA = SIG20 + SIG21
      A     = -(BETA+SIG21)
      B     = (SIG01-SIG21)
      F     = (SIG10-SIG20)
      G     = -(ALPHA+SIG20)
      D     = A*G-B*F
      Q     = 0.5*DSQRT((G-A)**2+4*B*F)
      SIGSUM= -(A+G)
      S     = 0.5*(G-A)
 
      FE0  = (BETA *SIG20+SIG10*SIG21)/D
      FE1  = (ALPHA*SIG21+SIG01*SIG20)/D
      FE2  = (SIG20*(A-B)+G*(A+SIG21)-F*(B+SIG21))/D

      P(0,1)  =  1.0/2./Q*(B*FE2+(B+S-Q)*FE1)
      P(1,1)  = -1.0/2./Q*((S-Q)*(1.0-FE1)+B*FE0)
      P(2,1)  =  1.0/2./Q*(FE1*(S-Q)-B*FE0)
      P(0,0)  =  P(0,1)  *(S+Q)/B
      P(1,0)  =  P(1,1)  *(S+Q)/B
      P(2,0)  =  P(2,1)  *(S+Q)/B
      P(0,2)  = -P(0,1)  *(B+S+Q)/B
      P(1,2)  = -P(1,1)  *(B+S+Q)/B
      P(2,2)  = -P(2,1)  *(B+S+Q)/B
      N(0,1)  = -1.0/2./Q*(B*FE2+(B+S+Q)*FE1)
      N(1,1)  =  1.0/2./Q*((S+Q)*(1.0-FE1)+B*FE0)
      N(2,1)  = -1.0/2./Q*(FE1*(S+Q)-B*FE0)
      N(0,0)  =  N(0,1)  *(S-Q)/B
      N(1,0)  =  N(1,1)  *(S-Q)/B
      N(2,0)  =  N(2,1)  *(S-Q)/B
      N(0,2)  = -N(0,1)  *(B+S-Q)/B
      N(1,2)  = -N(1,1)  *(B+S-Q)/B
      N(2,2)  = -N(2,1)  *(B+S-Q)/B

      IF (X2.EQ.0.) THEN 
        FE0 = 0.0D0
        FE1 = 0.0D0
        FE2 = 0.0D0
      ENDIF


C     INITIAL CHARGE STATE 0 ELECTRONS
      F00=FE0
     &+(P(0,0)*DEXP(PI*Q)+N(0,0)*DEXP(-PI*Q))*DEXP(-0.5D0*SIGSUM*PI)
      F01=FE1
     &+(P(0,1)*DEXP(PI*Q)+N(0,1)*DEXP(-PI*Q))*DEXP(-0.5D0*SIGSUM*PI)
      F02=FE2
     &+(P(0,2)*DEXP(PI*Q)+N(0,2)*DEXP(-PI*Q))*DEXP(-0.5D0*SIGSUM*PI)

C     INITIAL CHARGE STATE 1 ELECTRON
      F10=FE0
     &+(P(1,0)*DEXP(PI*Q)+N(1,0)*DEXP(-PI*Q))*DEXP(-0.5D0*SIGSUM*PI)
      F11=FE1
     &+(P(1,1)*DEXP(PI*Q)+N(1,1)*DEXP(-PI*Q))*DEXP(-0.5D0*SIGSUM*PI)
      F12=FE2
     &+(P(1,2)*DEXP(PI*Q)+N(1,2)*DEXP(-PI*Q))*DEXP(-0.5D0*SIGSUM*PI)

C     INITIAL CHARGE STATE 2 ELECTRONS
      F20=FE0 
     &+(P(2,0)*DEXP(PI*Q)+N(2,0)*DEXP(-PI*Q))*DEXP(-0.5D0*SIGSUM*PI)
      F21=FE1  
     &+(P(2,1)*DEXP(PI*Q)+N(2,1)*DEXP(-PI*Q))*DEXP(-0.5D0*SIGSUM*PI)
      F22=FE2 
     &+(P(2,2)*DEXP(PI*Q)+N(2,2)*DEXP(-PI*Q))*DEXP(-0.5D0*SIGSUM*PI)


      D0 = FR0*F00 + FR1*F10 + FR2*F20
      D1 = FR0*F01 + FR1*F11 + FR2*F21
      D2 = FR0*F02 + FR1*F12 + FR2*F22

      X2 = DSQRT(F00**2+F01**2+F02**2 + F10**2+F11**2+F12**2 + 
     &           F20**2+F21**2+F22**2 )

      RETURN
      END
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC



      SUBROUTINE TARGET(Z_T,A_T,RHO)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C     Reads target data
C
C     Z_T    : Nuclear charge of target
C     A_T    : Mass number of target nucleus
C     RHO    : Density of target material in g/cm3
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      CHARACTER*70 CHR1
 
      COMMON /CONSTAN/ AU_FC,EM_FC,C_FC,ALPHA_FC,A0_FC,RY_FC,PI_FC,U_FC      
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      OPEN(UNIT=20,FILE='target.data',
     & STATUS='OLD')

      DO 5 I=1,7
        READ(20,'(A70)') CHR1
5     CONTINUE      

      DO 10 I=1,92
        READ(20,*) ZTS,A_T,RHO
        IF(ZTS.EQ.Z_T) GOTO 20
10    CONTINUE

      Z_P =0.D0
      Z_T =0.D0
      WRITE(*,*) 'TARGET DATA NOT FOUND'
      IF(1.EQ.1) STOP

20    CONTINUE
      CLOSE(UNIT=20)
      RETURN
      END
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC



